-- MixScript, generující různě rychle rostoucí pilový signál, použitelný jako nastavitelný časovač
--  ve spojitosti s logickými spínači, případně s FlipFlop logickým spínačem (Sticky) může generovat hodinový signál.

-- CtrlSrc - zdroj nejspíš sem chcete potenciometr, ale klidně si časovač řiďte plynem.
--  CtrlSrc brzdí časovač. Tedy čím kladnější hodnota, tím běží časovač pomaleji
-- Incr - je přírůstek výstupní osy, po překročení 1024 (100%) se vrací na konstantní hodnotu -1024 (-100%)
-- při nesoudělnosti rozsahu a přírůstku maximální hodnota nemusí dosánout maximální hodnoty 100% - je potřeba s tím počítat při vyhodnocování signálu
---
local	input =	{
    { "CtrlSrc", SOURCE },
    { "Incr", VALUE, 0, 100, 30}
}

local output = { "SawChannel" }

local retval = -1024
local lastTm


local	function	init_func()
    lastTm = getTime()
end

local	function	run_func(ctrl, spd)
    if (getTime() - lastTm > (ctrl+1024)/100) then
        retval = retval + spd
        if (retval > 1024) then
            retval = -1024
        end
        lastTm = getTime()
    end
    return retval;
end

return { input=input, output=output, run=run_func, init=init_func }